#include <sdkhooks>
#include <shop>

public Plugin myinfo = 
{
	name = "(Shop) Survivability | Выживаемость",
	author = "Drumanid",
	version = "1.0",
	url = "Discord: Drumanid#9108"
};

int g_iPrice, g_iSellPrice, g_iGoldPrice, g_iGoldSellPrice, g_iDuration;
bool g_bIsOn[MAXPLAYERS +1], g_bUse[MAXPLAYERS +1], g_bFade, g_bGame;
char g_sWeapon[512];
ItemId g_iId;

public APLRes AskPluginLoad2(Handle hMySelf, bool bLate, char[] szError, int iErrMax)
{
	MarkNativeAsOptional("Shop_SetItemGoldPrice");
	MarkNativeAsOptional("Shop_SetItemGoldSellPrice");

	if(GetEngineVersion() == Engine_CSGO) g_bGame = true;
	else g_bGame = false;
	
	return APLRes_Success;
}

public void OnPluginStart()
{
	HookEvent("player_spawn", PlayerSpawn);
	
	if(Shop_IsStarted()) Shop_Started();
	AutoExecConfig(true, "shop_survivability", "shop");
}

public void OnPluginEnd()
{
	Shop_UnregisterMe();
}

public void Shop_Started()
{
	CategoryId category_id = Shop_RegisterCategory("ability", "Способности", "");
	if(Shop_StartItem(category_id, "Survivability"))
	{
		ConVar cv;
		(cv = CreateConVar("shop_survivability_weapon", "awp|knife|decoy", "Список оружия от которого можно получить урон и вас не спасет 'выживаемость'")).AddChangeHook(Cvar_Weapon);
		cv.GetString(g_sWeapon, sizeof(g_sWeapon));
		(cv = CreateConVar("shop_survivability_fade", "1", "1 - включить | 0 - выключить эффект ", _, true, 0.0, true, 1.0)).AddChangeHook(Cvar_Fade);
		g_bFade = cv.BoolValue;
		(cv = CreateConVar("shop_survivability_price", "2500", "Цена покупки 'выживаемости'")).AddChangeHook(Cvar_Price);
		g_iPrice = cv.IntValue;
		(cv = CreateConVar("shop_survivability_sellprice", "1250", "Цена продажи 'выживаемости'")).AddChangeHook(Cvar_SellPrice);
		g_iSellPrice = cv.IntValue;
		(cv = CreateConVar("shop_survivability_goldprice", "100", "Цена покупки за золото 'выживаемости'")).AddChangeHook(Cvar_GoldPrice);
		g_iGoldPrice = cv.IntValue;
		(cv = CreateConVar("shop_survivability_goldsellprice", "50", "Цена продажи за золото 'выживаемости'")).AddChangeHook(Cvar_GoldSellPrice);
		g_iGoldSellPrice = cv.IntValue;
		(cv = CreateConVar("shop_survivability_duration", "86400", "Время действия 'выживаемости' после покупки")).AddChangeHook(Cvar_Duration);
		g_iDuration = cv.IntValue;
	
		Shop_SetInfo("Выживаемость", "Возможность остаться в живых от смертельного ранения", g_iPrice, g_iSellPrice, Item_Togglable, g_iDuration, g_iGoldPrice, g_iGoldSellPrice);
		Shop_SetCallbacks(OnItemRegistered, OnEquipItem, _, _, _, _, _, ItemSellCallback);
		Shop_EndItem();
	}
}

public void Cvar_Weapon(ConVar cv, const char[] oldValue, const char[] newValue)
{
	cv.GetString(g_sWeapon, sizeof(g_sWeapon));
}

public void Cvar_Fade(ConVar cv, const char[] oldValue, const char[] newValue)
{
	g_bFade = cv.BoolValue;
}

public void Cvar_Price(ConVar cv, const char[] oldValue, const char[] newValue)
{
	g_iPrice = cv.IntValue;
	Shop_SetItemPrice(g_iId, cv.IntValue);
}

public void Cvar_SellPrice(ConVar cv, const char[] oldValue, const char[] newValue)
{
	g_iSellPrice = cv.IntValue;
	Shop_SetItemSellPrice(g_iId, cv.IntValue);
}

public void Cvar_GoldPrice(ConVar cv, const char[] oldValue, const char[] newValue)
{
	g_iGoldPrice = cv.IntValue;
	Shop_SetItemGoldPrice(g_iId, cv.IntValue);
}

public void Cvar_GoldSellPrice(ConVar cv, const char[] oldValue, const char[] newValue)
{
	g_iGoldSellPrice = cv.IntValue;
	Shop_SetItemGoldSellPrice(g_iId, cv.IntValue);
}

public void Cvar_Duration(ConVar cv, const char[] oldValue, const char[] newValue)
{
	g_iDuration = cv.IntValue;
}

public void OnItemRegistered(CategoryId category_id, const char[] sCategory, const char[] sItem, ItemId item_id) 
{
	g_iId = item_id;
}

public ShopAction OnEquipItem(int iClient, CategoryId category_id, const char[] sCategory, ItemId item_id, const char[] sItem, bool bIsOn, bool bElapsed)
{
	if(bIsOn || bElapsed)
	{
		SDKUnhook(iClient, SDKHook_OnTakeDamage, OnTakeDamage);
		g_bIsOn[iClient] = false;
		return Shop_UseOff;
	}

	SDKHook(iClient, SDKHook_OnTakeDamage, OnTakeDamage);
	g_bIsOn[iClient] = true;
	return Shop_UseOn;
}

public bool ItemSellCallback(int iClient, CategoryId category_id, const char[] sCategory, ItemId item_id, const char[] sItem, ItemType type, int iSellPrice, int iSellGoldPrice)
{
	SDKUnhook(iClient, SDKHook_OnTakeDamage, OnTakeDamage);
	g_bIsOn[iClient] = false;
	return true;
}

public void OnClientDisconnect(int iClient)
{
	g_bIsOn[iClient] = false;
}

public void PlayerSpawn(Event hEvent, const char[] sName, bool bDbc)
{
	g_bUse[GetClientOfUserId(hEvent.GetInt("userid"))] = false;
}

public Action OnTakeDamage(int iVictim, int &iAttacker, int &iInflictor, float &fDamage, int &iDamageType)
{
	if(iAttacker && iAttacker != iVictim && g_bIsOn[iVictim] && !g_bUse[iVictim] && (GetClientHealth(iVictim) - RoundToCeil(fDamage)) <= 0)
	{
		int iWeapon;
		if((iWeapon = GetEntPropEnt(iAttacker, Prop_Data, "m_hActiveWeapon")) != -1)
		{
			char sWeapon[32];
			GetWeaponName(iWeapon, sWeapon, sizeof(sWeapon));
			
			if(!(StrContains(g_sWeapon, sWeapon[FindCharInString(sWeapon, '_') +1], false) != -1))
			{
				if(g_bFade)
				{
					Handle hMessage = StartMessageOne("Fade", iVictim);
					if(g_bGame)
					{
						PbSetInt(hMessage, "duration", 150);
						PbSetInt(hMessage, "hold_time", 1);
						PbSetInt(hMessage, "flags", 0x0001);
						PbSetColor(hMessage, "clr", {255, 0, 0, 100});
					}
					else
					{
						BfWriteShort(hMessage, 150);
						BfWriteShort(hMessage, 1);
						BfWriteShort(hMessage, 0x0001);
						BfWriteByte(hMessage, 255);
						BfWriteByte(hMessage, 0);
						BfWriteByte(hMessage, 0);
						BfWriteByte(hMessage, 100);
					}
					EndMessage();
				}
			
				SetEntityHealth(iVictim, 1);
				g_bUse[iVictim] = true;
			
				return Plugin_Handled;
			}
		}
	}
	
	return Plugin_Continue;
}

void GetWeaponName(int iWeapon, char[] sWeapon, int iSize)
{
	switch(GetEntProp(iWeapon, Prop_Send, "m_iItemDefinitionIndex"))
	{
		case 60: strcopy(sWeapon, iSize, "weapon_m4a1_silencer");
		case 61: strcopy(sWeapon, iSize, "weapon_usp_silencer");
		case 63: strcopy(sWeapon, iSize, "weapon_cz75a");
		case 64: strcopy(sWeapon, iSize, "weapon_revolver");
		default: GetEdictClassname(iWeapon, sWeapon, iSize);
	}
}